#include <iostream>
#include <string>
using namespace std;

/* Include Dummy Code to make demo compile */
/* Ignore for refactoring demo! */
#include "DummyCode.cpp"
/* End of code to be ignored */

bool istZutatVorhanden(VorhandeneZutaten &vorhandeneZutaten, const string &zutat);
bool sindAlleZutatenVorhanden(VorhandeneZutaten &vorhandeneZutaten, Rezept *rezept);

void ausgabeRezept(int rezeptNummer, std::string name);
void ausgabeResultat(std::string result);

void pruefeRezept(VorhandeneZutaten &vorhandeneZutaten, int i);

// This is the original function that has been refactored:
void pruefeRezepte(VorhandeneZutaten vorhandeneZutaten){
    for (int i=0; i<getAnzahlRezepte(); i++){
        pruefeRezept(vorhandeneZutaten, i);
    }
}

void pruefeRezept(VorhandeneZutaten &vorhandeneZutaten, int i) {
    Rezept* rezept = getRezept(i);

    ausgabeRezept(i,rezept->getRezeptName());

    if (sindAlleZutatenVorhanden(vorhandeneZutaten, rezept)) {
        ausgabeResultat(" mischbar!");
    }
    else {
        ausgabeResultat(" nicht mischbar!");
    }
}


void ausgabeRezept(int rezeptNummer, std::string name) {
    cout << rezeptNummer << ". " << name << ": ";
}
void ausgabeResultat(std::string result) {
    cout << result << endl;
}
bool sindAlleZutatenVorhanden(VorhandeneZutaten &vorhandeneZutaten, Rezept *rezept) {
    for (int j = 0; j < rezept->getAnzahlRezeptZutaten(); j++) {
        string zutat = rezept->getZutat(j);
        if (!istZutatVorhanden(vorhandeneZutaten, zutat)) {
            return false;
        }
    }
    return true;
}

bool istZutatVorhanden(VorhandeneZutaten &vorhandeneZutaten, const string &zutat) {
    for (int k=0; k < vorhandeneZutaten.getAnzahlZutaten(); k++){
        if (zutat == vorhandeneZutaten.getVorhandeneZutat(k)){
            return true;
        }
    }
    return false;
}
